
#include "FileHandling.h"
#include "StringHandling.h"
#include "VocList.h"
using namespace std;

// Writes a string to a file
// Returns true if the write was succesful and false otherwise
bool writeToFile(const string &file, const string &data)
{
  bool retval = false;
  ofstream outFile(file.c_str());
  if(outFile.is_open())
    {
      outFile << data;
      outFile.close();
      retval = true;
    }
  // else retval = false (which it is already)
  
  return retval;
}

// Does the proper operations on a voclist and saves is as text in a vocfile
// Returns true if the write was succesful and false otherwise
bool writeToFile(const string &file, VocList &vlist,
		 const string &wordDelim, const string &langDelim)
{
  bool retval = false;
  ofstream outFile(file.c_str());
  if(outFile.is_open())
    {
      for(unsigned int i = 0; i < vlist.size(); i++)
	{
	  outFile << stringDeque2String(vlist.getVoc(i).getQuestions(false),
					wordDelim)
		  << langDelim
		  << stringDeque2String(vlist.getVoc(i).getAnswers(false),
					wordDelim)
		  << endl;
	}
      outFile.close();
      retval = true;
    }
  // else retval = false (which it already is)
  
  return retval;
}

// Checks wheter or not a given file exists
bool fileExists(const string &file)
{
  ifstream inFile(file.c_str());
  bool exists = false;
  
  if(inFile.is_open())
    exists = true;

  inFile.close();
  return exists;
}
