
#include "StringHandling.h"
using namespace std;

// Removes leading whitespaces
void rmLeadWs(string &s)
{
  if(s != "")
    {
      while(s.find(' ') == 0)
	s = s.substr(1, s.length());
    }

  return;
}

// Removes trailing whitespaces
void rmTrailWs(string &s)
{
  if(s != "")
    {
      // rfind() will return the position of the character starting from 0
      // length() will return the length of the string (ie 0 = "")
      while(s.rfind(' ') == s.length() - 1)  // -1 due to the comment above
	s = s.substr(0, s.length() - 1); // Throw the last char away (ws)
    }

  return;
}

// Remove all comments (everything behind "//") from a string
void rmComments(string &row)
{
  if(row.find("//") != string::npos)
    {
      unsigned int pos = row.find("//");
      row = row.substr(0, pos);
    }
  return;
}


// Filter out the different translations from a string containing a lot of them
deque<string> split(string &s, const string &wordDelim)
{
  deque<string> wordList;
  unsigned int pos = s.find(wordDelim);
  while((s.find(wordDelim) != string::npos) && (pos != s.length() - 1))
    {
      string word = s.substr(0, pos);
      rmLeadWs(word);
      rmTrailWs(word);
      s = s.substr(pos + wordDelim.length(), s.length());
      wordList.push_back(word);
      pos = s.find(wordDelim);
    }
  
  // If we did have a wordDelim, the last word wont have been added
  // If we didn't have a wordDelim we wont have added even the single word
  rmLeadWs(s);
  rmTrailWs(s);
  wordList.push_back(s);
  
  return wordList;
}

// Converts a deque<string> and a delim to a single string
string stringDeque2String(const deque<string> &sd, const string &delim)
{
  string manyWords = "";
  for(unsigned int i = 0; i < sd.size() - 1; i++) // Add the first n-1 words with delim
    manyWords += sd[i] + delim;
  
  if(sd.size() >= 1) // Add the last word without the delim after it
    manyWords += sd[sd.size() - 1];
  
  return manyWords;
}




